'Aufgabe 7.23 Turm von Hanoi
DECLARE SUB hanoi (n!, start!, ziel!, zwischen!)
DECLARE SUB legeum (a!, b!)
DECLARE SUB scheibe (x!, kx!, i!, farbe!)
DECLARE FUNCTION schBreite! (i!)
DECLARE SUB bild ()
CLS
PRINT "Turm von Hanoi"
PRINT
DIM SHARED n
INPUT "Anzahl der Scheiben: ", n
DIM SHARED turm(3, n)
DIM SHARED scheibenHoehe
IF n < 5 THEN
 scheibenHoehe = 40
ELSE
 scheibenHoehe = 200 / n
END IF
FOR i = 1 TO n
 turm(1, i) = i
NEXT
SCREEN 12
WINDOW (0, 0)-(640, 480)
bild
hanoi n, 1, 2, 3

SUB bild
 FOR t = 1 TO 3
  FOR k = 1 TO n
   IF turm(t, k) > 0 THEN
    scheibe t, k, turm(t, k), 15
   END IF
  NEXT
 NEXT
 LOCATE 28, 1
 PRINT "Weiter mit irgendeiner Taste"
 WHILE INKEY$ = ""
 WEND
END SUB

SUB hanoi (n, start, ziel, zwischen)
 IF n > 0 THEN
  hanoi n - 1, start, zwischen, ziel
  legeum start, ziel
  hanoi n - 1, zwischen, ziel, start
 END IF
END SUB

SUB legeum (a, b)
 ka = n
 WHILE turm(a, ka) = 0 AND ka > 0
  ka = ka - 1
 WEND
 kb = n
 WHILE turm(b, kb) = 0 AND kb > 0
  kb = kb - 1
 WEND
 kb = kb + 1
 turm(b, kb) = turm(a, ka)
 scheibe a, ka, turm(a, ka), 0
 turm(a, ka) = 0
 scheibe b, kb, turm(b, kb), 15
 WHILE INKEY$ = ""
 WEND
END SUB

FUNCTION schBreite (i)
 schBreite = 40 + 110 * (n - i) / n
END FUNCTION

SUB scheibe (x, kx, i, farbe)
 LINE (80 + x * 160 - .5 * schBreite(i), 50 + (kx - .4) * scheibenHoehe)-(80 + x * 160 + .5 * schBreite(i), 50 + (kx + .4) * scheibenHoehe), farbe, BF
END SUB

